//	jpegt@CE90x]ĕۑ邒(GDI+)
//	Visual C++ 2008/2013	32/64bit

#include <windows.h>
#include <gdiplus.h>
#include <tchar.h>

#pragma comment(lib,"gdiplus.lib")

using namespace Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR           gdiToken;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL InitApp(HINSTANCE, WNDPROC, TCHAR*);
BOOL InitInstance(HINSTANCE, TCHAR*, int);
HWND hWnd;

//	jpegGR[_[擾
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);



// ŏɌĂяo֐

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* lpsCmdLine, int nCmdShow){
	GdiplusStartup(&gdiToken, &gdiSI, NULL);
	CLSID     encoderClsid;
	if(GetEncoderClsid(L"image/jpeg", &encoderClsid)<0){
		MessageBox(0,TEXT("jpegGR[_[擾ł܂łB"),TEXT("G["),MB_OK);
		return (int)1;
	}

	TCHAR* srcFile = TEXT("src.jpg");	//	ǂݍރt@Cw
	TCHAR* dtcFile = TEXT("dtc.jpg");	//	ۑt@Cw

#ifndef UNICODE
	WCHAR srcFileW[MAX_PATH];
	MultiByteToWideChar(932, 0, srcFile, -1, srcFileW, sizeof(srcFileW) / sizeof(TCHAR));
	Image& srcImage = *Bitmap::FromFile(srcFileW);
#else
	Image& srcImage = *Bitmap::FromFile(srcFile);
#endif
	if (&srcImage == NULL){
		MessageBox(0, _TEXT("\[Xt@CJ܂ł"), _TEXT("G["), MB_OK);
		return 2;
	}

	int px = srcImage.GetWidth();
	int py = srcImage.GetHeight();
	float xDpi = srcImage.GetHorizontalResolution();
	float yDpi = srcImage.GetVerticalResolution();

	Bitmap& dtcBmp = *(new Bitmap(py, px));
	dtcBmp.SetResolution(xDpi , yDpi);
	Graphics& dtcGraphics = *Graphics::FromImage(&dtcBmp);
//	EEEE̍WE90x]Ww肷B
	Point pt[] = { Point(py, 0), Point(py, px), Point(0, 0) };

	dtcGraphics.DrawImage(&srcImage, pt, 3);
	srcImage.~Image();
	Status s;
#ifndef UNICODE
	WCHAR dtcFileW[MAX_PATH];
	MultiByteToWideChar(932, 0, dtcFile, -1, dtcFileW, sizeof(dtcFileW) / sizeof(TCHAR));
	s = dtcBmp.Save(dtcFileW, &encoderClsid);
#else
	s = dtcBmp.Save(dtcFile, &encoderClsid);
#endif

	if (s != Ok){
		MessageBox(0, _TEXT("fBXeBl[Vt@CJ܂ł"), _TEXT("G["), MB_OK);
		return 2;
	}

	delete &dtcBmp;
	dtcGraphics.~Graphics();

	GdiplusShutdown(gdiToken);

	return 0;
}

//	jpegGR[_[擾

int GetEncoderClsid(const WCHAR* format, CLSID* pClsid) {
	UINT  num = 0;
	UINT  size = 0;
	ImageCodecInfo* pImageCodecInfo;
	GetImageEncodersSize(&num, &size);
	if (size == 0)
		return -1;
	pImageCodecInfo = (ImageCodecInfo*)new char[size];
	if (pImageCodecInfo == NULL)
		return -1;
	GetImageEncoders(num, size, pImageCodecInfo);
	for (UINT n = 0; n<num; ++n) {
		if (wcscmp(pImageCodecInfo[n].MimeType, format) == 0) {
			*pClsid = pImageCodecInfo[n].Clsid;
			delete pImageCodecInfo;
			return n;
		}
	}
	delete pImageCodecInfo;
	return -1;
}
